{
  TEST100 - Testprogramm fr den Modus 100h ( 640 x 400 x 256 )

  Demonstration der SVGA-Routinen mit Borland Pascal 7.0 Protected Mode.
  Dieses Programm ist NUR im Protected Mode lauffhig.

  Ansgar Scherp   ( Ansgar.Scherp@Informatik.Uni-Oldenburg.DE )
  Joachim Gelhaus ( J.Gelhaus@Flight.Gun.DE )

  http://www.informatik.uni-oldenburg.de/~virtech/

  aus 'Patchwork' c't 4/97 S. 442

}

{$IFNDEF DPMI}Nur im Protected Mode lauffhig...{$ENDIF}

uses Video100, Video13, DPMI, Crt;

var
  MyPage100h,
  MyBackground100h : TPage100h; { zwei virtuelle Bildschirmseiten }
  MySprite,
  MySprite2        : TSprite;   { zwei Sprites }
  x, y             : integer;   { Hilfvariable }
  DeltaX, DeltaY   : integer;   { zur Sin-/Cos-Berechnung }
  RealX, RealY     : real;
  Ende             : boolean;

begin
  ClrScr;
  WriteLn( 'VESA-VBE-Informationen : ' );
  { Mode 100h initialisieren }
  InitVideo100h;
  WriteLn;
  WriteLn( 'Taste drcken.' );
  ReadKey;
  { visuelle Seite lschen }
  ClearVisualPage100h;
  { virtuellen Seiten einrichten }
  InitPage100h( MyBackground100h );
  InitPage100h( MyPage100h );
  { virtuellen Seiten lschen }
  ClearPage100h( MyBackground100h );
  ClearPage100h( MyPage100h );
  { Fensterrahmen festlegen; kompletten Modus ausnutzen }
  SetWindow100h( 0, 0, 639, 479 );
  { Mode 100h einschalten }
  SetVideoMode100h( Mode100h );
  { Sprite initialisieren }
  InitSprite( MySprite, 100, 100 );
  { einen kleinen Farbverlauf erzeugen }
  for x := 0 to 31 do
    SetRGBColor( x, 0, 2 * x, 0 );
  for x := 0 to 31 do
    SetRGBColor( x + 32, x, 62 , 0 );
  { Sprite mit Pixeln fllen }
  for x := 0 to 99 do
    for y := 0 to 99 do
      PutPixel2Sprite( MySprite, x, y, Trunc ( sqrt ( x * y ) ) mod 256 );
  { nur, um zu sehen ob es luft }
  CopyP2P100h( MyPage100h, MyPage100h );
  { aktuelle I/O-Seite festlegen }
  ActivePage100h( MyPage100h );
  { Sprite an der Position 0,0 zeichnen }
  PutSprite100h( 0,0, MySprite );
  { testen von Put- und GetPixel; legt drei Kopien des Bildbereiches
    von 0,0 bis 99,99 an }
  RealX := 0; RealY := 0;
  for x := 0 to 99 do
    for y := 0 to 99 do
      begin
        PutPixel100h( x + 100, y      , GetPixel100h( 99 - x, y      ) );
        PutPixel100h( x      , y + 100, GetPixel100h( x     , 99 - y ) );
        PutPixel100h( x + 100, y + 100, GetPixel100h( 99 - x, 99 - y ) );
      end;
  { initialisiert ein zweites Sprite der Gre von 200 x 200 Pixeln }
  InitSprite( MySprite2, 200, 200 );
  { sichern des Bildinhaltes der gerade aktiven virtuellen Bildschirmseite
    in MySprite2 }
  GetSprite100h( 0,0, MySprite2 );
  { aktive virtuelle Bildschirmseite festlegen }
  ActivePage100h( MyBackground100h );
  { Hintergrundmuster erzeugen }
  for x := 0 to 3 do
    for y := 0 to 2 do
      PutSprite100h( x * 200, y * 200, MySprite2 );
  ActivePage100h( MyPage100h );
  Ende := false;
  repeat
    { Hinterrund nur zeichnen, wenn Ende = false }
    if not Ende then
      CopyP2P100h( MyBackground100h, MyPage100h );
    { Delta-Werte fr den Fensterrahmen berechnen }
    DeltaX := Round( Sin( RealX ) * 100 );
    DeltaY := Round( Cos( RealY ) * 100 );
    RealX := RealX + PI/128;
    RealY := RealY + PI/64;
    { Fensterrahmen stndig aendern }
    SetWindow100h( 50 - DeltaX, 50 - DeltaY,
                   639 - 50 - DeltaX, 479 + 50 - DeltaY );
    { Fensterrahmen mit Inhalt fllen }
    for x := -1 to 3 do
      for y := -1 to 2 do
        PutSprite100h( x * 200 + DeltaX, y * 200 + DeltaY, MySprite2 );
    { auf den vertikalen Strahlrcklauf des Monitors warten }
    WaitVerticalRetrace;
    { die aktive virtuelle Bildschirmseite in die visuelle Bildschirmseite
      kopieren }
    CopyP2V100h( MyPage100h );
    { wenn Taste gedrckt... }
    if ( Keypressed = true ) and ( Ende = false ) then
      begin
        ReadKey;        { ... dann Bildschirm lschen und zweiten Teil }
        Ende := true;   {     der Demonstration ausfhren }
        ClearPage100h( MyPage100h );
      end;
  until Keypressed and Ende;
  ReadKey;
  { allozierter Speicher fr die Sprites wieder freigeben }
  CloseSprite( MySprite );
  CloseSprite( MySprite2 );
  { virtuellen Bildschirmseiten schliessen }
  ClosePage100h( MyPage100h );
  ClosePage100h( MyBackground100h );
  { Textmodus 3h einschalten }
  SetVideoMode( Mode3h );
  WriteLn( 'Ende.' );
end.